// R. Anido
// Pulo do gato - OBI2018

import java.util.Scanner;
import java.util.Queue;
import java.util.LinkedList;
import javafx.util;

public class gato_java {
    
    public static void main(String[] args) {
	Scanner in = new Scanner(System.in);

	int L = in.nextInt();
	int C = in.nextInt();

	pair<in,int>[] q;
	Queue<pair<int,int>> q = new LinkedList<>();
	
	int[][] p = new int[L][C];
	int[][] dist = new int[L][C];

	for (int i = 0; i < L; i++)
	    for (int j = 0; j < C; j++) {
		p[i][j] = in.nextInt();
		dist[i][j] = -1;
	    }

	// BFS
	dist[0][0] = 0;
	q.add(new Pair(0,0));

	while( True ){
	    Pair p = q.poll();
	    if (p == null) break;
	    int i = p.K;
	    int j = p.V;
	    
	    // possiveis pulos
	    for (int a = i-2; a <= i+2; a++)
		for (int b = j-2; b <= j+2; b++)
		    if (a >= 0 && a < L && b >= 0 && b < C)
			if (p[a][b] == 1 && dist[a][b] == -1){
			    dist[a][b] = dist[i][j]+1;
			    q.add(new Pair(a,b));
			}
	}
	
	System.out.println(dist[L-1][C-1]);
    }
}
